package com.gic.haoban.manage.service.service.hm.impl;

import java.util.List;
import java.util.stream.Collectors;

import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.UniqueIdUtils;
import com.gic.haoban.manage.api.dto.hm.HmLinkChatDTO;
import com.gic.haoban.manage.service.dao.mapper.hm.HmLinkChatMapper;
import com.gic.haoban.manage.service.entity.hm.TabHmLinkChat;
import com.gic.haoban.manage.service.service.hm.HmLinkChatService;

@Service("hmLinkChatService")
public class HmLinkChatServiceImpl implements HmLinkChatService {

    @Autowired
    private HmLinkChatMapper hmLinkChatMapper;

    @Override
    public List<HmLinkChatDTO> listByLinkId(String wxEnterpriseId, String enterpriseId, Long linkId) {
        return this.hmLinkChatMapper.listByLinkId(wxEnterpriseId, enterpriseId, linkId);
    }

    @Override
    public int save(Long linkId, List<HmLinkChatDTO> list) {
        List<HmLinkChatDTO> updateList = list.stream().filter(dto -> null != dto.getChatHmId())
                .collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(updateList)) {
            List<Long> notDelIdList = updateList.stream().map(dto -> dto.getChatHmId()).collect(Collectors.toList());
            this.hmLinkChatMapper.delete(linkId, notDelIdList);
            for (HmLinkChatDTO item : updateList) {
                TabHmLinkChat entity = EntityUtil.changeEntityByJSON(TabHmLinkChat.class, item);
                this.hmLinkChatMapper.update(entity);
            }
        }
        List<HmLinkChatDTO> addList = list.stream().filter(dto -> null != dto.getChatHmId())
                .collect(Collectors.toList());
        if (CollectionUtils.isNotEmpty(addList)) {
            for (HmLinkChatDTO dto : addList) {
                TabHmLinkChat entity = EntityUtil.changeEntityByJSON(TabHmLinkChat.class, dto);
                entity.setChatHmId(UniqueIdUtils.uniqueLong());
                entity.setLinkId(linkId);
                this.hmLinkChatMapper.insert(entity);
            }
        }
        return 0;
    }

}
